GLOBAL.setmetatable(env, {
    __index = function(t, k) return GLOBAL.rawget(GLOBAL, k) end
})

TUNING.XXX3_WF_PRODUCEBUTTERFLY = GetModConfigData("xxx3_wf_producebutterfly")
TUNING.XXX3_WF_PRODUCEFIREFLY = GetModConfigData("xxx3_wf_producefirefly")
TUNING.XXX3_WF_PRODUCEITEM = GetModConfigData("xxx3_wf_produceitem")

--加入新科技树
modimport("scripts/newtech_xxx3.lua")

PrefabFiles = {
	"xxx3",
	"xxx3_none",
    "xxx3_wf",
    "xxx3_sf",
    "xxx3_bf",
    "xxx3_sf_nf",
    "xxx3_hat",
    "xxx3_pollen",
    "xxx3_seed",
    "xxx3_food",
    "xxx3_ydg",
    "xxx3_bulbfx",
    "xxx3_bouquet",
    "xxx3_killerbutterfly",
    "xxx3_butterflybuff",
    "xxx3_healthregenbuff",

}

function AddPrefabFiles(...)
	for _,v in ipairs({...})do table.insert(PrefabFiles, v) end
end
local function import(t)
	for _,v in ipairs(t)do modimport("main/"..v) end
end
import{
	'myeyeplant'
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/xxx3.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/xxx3.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/xxx3.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/xxx3.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/xxx3_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/xxx3_silho.xml" ),

    Asset( "IMAGE", "bigportraits/xxx3.tex" ),
    Asset( "ATLAS", "bigportraits/xxx3.xml" ),
	
	Asset( "IMAGE", "images/map_icons/xxx3.tex" ),
	Asset( "ATLAS", "images/map_icons/xxx3.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_xxx3.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_xxx3.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_xxx3.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_xxx3.xml" ),
	
	Asset( "IMAGE", "images/avatars/self_inspect_xxx3.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_xxx3.xml" ),
	
	Asset( "IMAGE", "images/names_xxx3.tex" ),
    Asset( "ATLAS", "images/names_xxx3.xml" ),
	
	Asset( "IMAGE", "images/names_gold_xxx3.tex" ),
    Asset( "ATLAS", "images/names_gold_xxx3.xml" ),
    
    Asset( "IMAGE", "images/xxx3_butterfly.tex" ),
    Asset( "ATLAS", "images/xxx3_butterfly.xml" ),

    Asset( "IMAGE", "images/xxx3_wf.tex" ),
    Asset( "ATLAS", "images/xxx3_wf.xml" ),

    Asset( "IMAGE", "images/xxx3_sf.tex" ),
    Asset( "ATLAS", "images/xxx3_sf.xml" ),

    Asset( "IMAGE", "images/xxx3_bf.tex" ),
    Asset( "ATLAS", "images/xxx3_bf.xml" ),

    Asset( "IMAGE", "images/xxx3_lureplant.tex" ),
    Asset( "ATLAS", "images/xxx3_lureplant.xml" ),

    Asset( "IMAGE", "images/xxx3_hat.tex" ),
    Asset( "ATLAS", "images/xxx3_hat.xml" ),

    Asset( "IMAGE", "images/xxx3_pollen.tex" ),
    Asset( "ATLAS", "images/xxx3_pollen.xml" ),

    Asset( "IMAGE", "images/xxx3_seed.tex" ),
    Asset( "ATLAS", "images/xxx3_seed.xml" ),

    Asset( "IMAGE", "images/xxx3_hmhb.tex" ),
    Asset( "ATLAS", "images/xxx3_hmhb.xml" ),

    Asset( "IMAGE", "images/xxx3_hjmdj.tex" ),
    Asset( "ATLAS", "images/xxx3_hjmdj.xml" ),

    Asset( "IMAGE", "images/xxx3_hbsl.tex" ),
    Asset( "ATLAS", "images/xxx3_hbsl.xml" ),

    Asset( "IMAGE", "images/xxx3_ydg.tex" ),
    Asset( "ATLAS", "images/xxx3_ydg.xml" ),

    Asset( "IMAGE", "images/xxx3_hjdg.tex" ),
    Asset( "ATLAS", "images/xxx3_hjdg.xml" ),

    Asset( "IMAGE", "images/xxx3_nmtd.tex" ),
    Asset( "ATLAS", "images/xxx3_nmtd.xml" ),

    Asset( "IMAGE", "images/xxx3_bouquet.tex" ),
    Asset( "ATLAS", "images/xxx3_bouquet.xml" ),
}

AddMinimapAtlas("images/map_icons/xxx3.xml")

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local ACTIONS = GLOBAL.ACTIONS
local ActionHandler = GLOBAL.ActionHandler

-- The character select screen lines
STRINGS.CHARACTER_TITLES.xxx3 = "芮塔"
STRINGS.CHARACTER_NAMES.xxx3 = "芮塔"
STRINGS.CHARACTER_DESCRIPTIONS.xxx3 = "*是一朵食人花\n*不会受到食人花的攻击\n*可以种植世界之花"
STRINGS.CHARACTER_QUOTES.xxx3 = "\"Quote\""
STRINGS.CHARACTER_SURVIVABILITY.xxx3 = "普通"

-- Custom speech strings
STRINGS.CHARACTERS.XXX3 = require "speech_xxx3"

-- The character's name as appears in-game 
STRINGS.NAMES.XXX3 = "芮塔"
STRINGS.SKIN_NAMES.xxx3_none = "Esc"

-- The skins shown in the cycle view window on the character select screen.
-- A good place to see what you can put in here is in skinutils.lua, in the function GetSkinModes
local skin_modes = {
    { 
        type = "ghost_skin",
        anim_bank = "ghost",
        idle_anim = "idle", 
        scale = 0.75, 
        offset = { 0, -25 } 
    },
}

STRINGS.NAMES.XXX3_WF = "世界花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_WF = "她真漂亮"
STRINGS.RECIPE_DESC.XXX3_WF = "集世间之华"

STRINGS.NAMES.XXX3_HAT = "眼球草花环"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_HAT = "我是眼球草"
STRINGS.RECIPE_DESC.XXX3_HAT = "我是眼球草"

STRINGS.NAMES.XXX3_SF = "金日玫"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_SF = "好像成熟了"

STRINGS.NAMES.XXX3_SF_NF = "金日玫"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_SF_NF = "再等等就能吃了"

STRINGS.NAMES.XXX3_BF = "完整的花"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_BF = "它完整了"
STRINGS.RECIPE_DESC.XXX3_BF = "它完整了"

STRINGS.NAMES.XXX3_SEED = "黄金花籽"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_SEED = "或许能种出好吃的"

STRINGS.NAMES.XXX3_POLLEN = "黄金花粉"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_POLLEN = "好像能吃"

STRINGS.NAMES.XXX3_YDG = "伊甸果"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_YDG = "金色传说！"

STRINGS.NAMES.XXX3_BOUQUET = "花束"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_BOUQUET = "也许可以用来送给喜欢的人"
STRINGS.RECIPE_DESC.XXX3_BOUQUET = "也许可以用来送给喜欢的人"

STRINGS.NAMES.XXX3_KILLERBUTTERFLY = "杀人蝶"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_KILLERBUTTERFLY = "美丽的死亡"

STRINGS.NAMES.XXX3_EYEPLANT_0 = "芮塔的眼球草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_EYEPLANT_0 = "眼睛真大！"

STRINGS.NAMES.XXX3_EYEPLANT_1 = "毒囊草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_EYEPLANT_1 = "一大朵花！"

STRINGS.NAMES.XXX3_EYEPLANT_2 = "火龙草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_EYEPLANT_2 = "看上去就很危险！"

STRINGS.NAMES.XXX3_EYEPLANT_3 = "岩棘草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_EYEPLANT_3 = "我可不想用手去打它。"

STRINGS.NAMES.XXX3_EYEPLANT_4 = "冰锤草"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XXX3_EYEPLANT_4 = "我很好奇它是怎么长出来的。"

---------------------------------------------------------

local xxx3tab = AddRecipeTab("花园", 600, "images/xxx3_wf.xml", "xxx3_wf.tex", "xxx3")

local xxx3_butterfly = AddRecipe("xxx3_butterfly", { Ingredient("petals", 1) }, xxx3tab, nil, nil, nil, true, nil, "xxx3", "images/xxx3_butterfly.xml", "xxx3_butterfly.tex", nil, "butterfly" )

local xxx3_wf = AddRecipe("xxx3_wf", { Ingredient("petals", 40) }, xxx3tab, nil, "xxx3_wf_placer", nil, nil, nil, "xxx3")
xxx3_wf.atlas = "images/xxx3_wf.xml"

local xxx3_lureplant = AddRecipe("xxx3_lureplant", { Ingredient("xxx3_seed", 1, "images/xxx3_seed.xml"), Ingredient("xxx3_pollen", 10, "images/xxx3_pollen.xml") }, xxx3tab, TECH.WF_ONE, nil, nil, nil, nil, "xxx3", "images/xxx3_lureplant.xml", "xxx3_lureplant.tex", nil, "lureplantbulb" )

local xxx3_hat = AddRecipe("xxx3_hat", { Ingredient("petals", 30), Ingredient("lureplantbulb", 1) }, xxx3tab, TECH.WF_ONE, nil, nil, nil, nil, "xxx3")
xxx3_hat.atlas = "images/xxx3_hat.xml"

local xxx3_bf = AddRecipe("xxx3_bf", { Ingredient("petals", 10) }, xxx3tab, TECH.WF_ONE, nil, nil, nil, nil, "xxx3")
xxx3_bf.atlas = "images/xxx3_bf.xml"

local xxx3_bouquet = AddRecipe("xxx3_bouquet", { Ingredient("xxx3_bf", 10) }, xxx3tab, TECH.WF_ONE, nil, nil, nil, nil, "xxx3")
xxx3_bouquet.atlas = "images/xxx3_bouquet.xml"

-----------------------------------------------------------

-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("xxx3", "FEMALE", skin_modes)

--加入新食谱
modimport("scripts/xxx3_foods") 

-- 食人花友好
AddPrefabPostInit("eyeplant", function(inst)
    if TheWorld.ismastersim then
        local RETARGET_MUST_TAGS = {'_combat', '_health'}
        local RETARGET_CANT_TAGS = {'INLIMBO', 'plantkin'}
        local RETARGET_ONEOF_TAGS = {'character', 'monster', 'animal', 'prey', 'eyeplant', 'lureplant'}
        local function retargetfn(inst)
            return FindEntity(
                inst,
                TUNING.EYEPLANT_ATTACK_DIST,
                function(guy)
                    return not (guy.components.health:IsDead() or guy:HasTag("eyeplant_friend") or guy:HasTag("eyeplant") or guy:HasTag("lureplant"))
                end,
                RETARGET_MUST_TAGS, -- see entityreplica.lua
                RETARGET_CANT_TAGS,
                RETARGET_ONEOF_TAGS
            )
        end
        inst.components.combat:SetRetargetFunction(0.2, retargetfn)
    end
end)

---------------------------------------------------------------
local function autoeat (inst,data)
    if data.newpercent and data.newpercent < .25 then
        local items=inst.components.inventory:FindItems(function(item)
            return item.components.edible and item.components.edible.hungervalue > 0
            and item.components.perishable
        end)

        for _,item in ipairs(items) do
            if inst.components.eater:CanEat(item) then
                inst.components.eater:Eat(item)
                break
            end
        end
    end
end

--技能状态
local bulb_state =State{
    name = "xxx3_turnintobulb",
    tags = {"hiding", "notalking", "nomorph", "busy", "nopredict", "nodangle","drowning"},

    onenter = function(inst)
        -- inst:PushEvent("nightvision", true)
        inst.components.hunger.burnratemodifiers:SetModifier(inst, 4.0,"quickconsume")
        inst:ListenForEvent("hungerdelta",autoeat)
        inst.check_starve = inst:DoPeriodicTask(3.5,function()
            if inst.components.hunger:IsStarving() then
                local items=inst.components.inventory:FindItems(function(item)
                    return item.components.edible and item.components.edible.hungervalue > 0
                    and item.components.perishable
                end)
                for _,item in ipairs(items) do
                    if inst.components.eater:CanEat(item) then
                        inst.components.eater:Eat(item)
                        break
                    end
                end
            end
        end)
        RemovePhysicsColliders(inst)
        inst.components.locomotor:Stop()
        if TheWorld.state.season == 'summer' then
            inst.components.health.fire_damage_scale = 0
        end
        inst.AnimState:PlayAnimation("hide")
        inst.AnimState:PushAnimation("hide_idle", false)
        inst.SoundEmitter:PlaySound("dontstarve/movement/foley/hidebush")
        inst.components.eater:SetStrongStomach(true) -- can eat monster meat!
        inst.components.eater:SetCanEatRawMeat(true)
    end,
    onexit = function (inst)
        inst.components.hunger.burnratemodifiers:RemoveModifier(inst,"quickconsume")
        inst:RemoveEventCallback("hungerdelta",autoeat)
        inst.components.eater:SetStrongStomach(false) -- can eat monster meat!
        inst.components.eater:SetCanEatRawMeat(false)
        if inst.check_starve then
            inst.check_starve:Cancel()
        end

        -- inst:PushEvent("nightvision", false)
        if inst.bulbfx then
            inst.bulbfx:Remove()
            inst.bulbfx = nil
        end

        if inst.components.freezable then
            inst.components.freezable:SetResistance(4)
        end
        if inst.collectmyitems then
            inst.collectmyitems:Cancel()
        end
        if inst.components.xxx3_minionspawner then
            inst.components.xxx3_minionspawner.shouldspawn = false
            inst.components.xxx3_minionspawner:KillAllMinions()
            inst:RemoveComponent("xxx3_minionspawner")
        end
        inst.Physics:CollidesWith(COLLISION.WORLD)
        inst.Physics:CollidesWith(COLLISION.OBSTACLES)
        inst.Physics:CollidesWith(COLLISION.SMALLOBSTACLES)
        inst.Physics:CollidesWith(COLLISION.CHARACTERS)
        inst.Physics:CollidesWith(COLLISION.GIANTS)
        inst.components.xxx3_skill:SetEnabled(false)
        inst.components.health.fire_damage_scale = 1
    end
}
AddStategraphState("wilson",bulb_state)
AddStategraphState("wilson_client",bulb_state)


---------------------------------------------------------------

--技能
local VALID_TILE_TYPES =
{
    [GROUND.DIRT] = true,
    [GROUND.SAVANNA] = true,
    [GROUND.GRASS] = true,
    [GROUND.FOREST] = true,
    [GROUND.MARSH] = true,

    -- CAVES
    [GROUND.CAVE] = true,
    [GROUND.FUNGUS] = true,
    [GROUND.SINKHOLE] = true,
    [GROUND.MUD] = true,
    [GROUND.FUNGUSRED] = true,
    [GROUND.FUNGUSGREEN] = true,

    --EXPANDED FLOOR TILES
    [GROUND.DECIDUOUS] = true,
}

local function OnCooldown(inst)
    inst._cdtask = nil
end

local function IsNotFull(inst,now)
    if inst == nil then
        return false
    end
    if not inst.components.inventory:IsFull() then
        return true
    else
        local items=inst.components.inventory:FindItems(function(item)
            return item.components.stackable ~= nil
        end)

        for i,item in ipairs(items) do
            if now.prefab == item.prefab and item.components.stackable and not item.components.stackable:IsFull() then
                return true
            end
        end
    end
    return false
end

local eattable = require('xxx3_table/eattable')

local function CollectItems(inst)
    if inst.components.xxx3_minionspawner.minions ~= nil then
        for k, v in pairs(inst.components.xxx3_minionspawner.minions) do
            if v.components.inventory ~= nil then
                for k = 1, v.components.inventory.maxslots do
                    local item = v.components.inventory.itemslots[k]
                    if item ~= nil and IsNotFull(inst, item) then
                        local it = v.components.inventory:RemoveItem(item)
                        inst.components.inventory:GiveItem(it)
                    elseif item ~= nil then
                        if inst.components.hunger and inst.components.hunger:GetPercent() < .25 then
                            if eattable[item.prefab] then
                                local health = eattable[item.prefab].health
                                local hunger = eattable[item.prefab].hunger
                                local sanity = eattable[item.prefab].sanity
                                if not inst.components.health:IsDead() then
                                    inst.components.health:DoDelta(health)
                                    inst.components.hunger:DoDelta(hunger)
                                    inst.components.sanity:DoDelta(sanity)
                                end
                                item:Remove()
                            elseif item.components.edible and item.components.edible.hungervalue > 0 and
                            item.components.perishable and inst.components.eater then
                                inst.components.eater:Eat(item)
                            end
                        end
                    end
                end
            end
        end
    end
end

local function chooseeyeplant(inst)
    if inst.components.xxx3_minionspawner then
        if TheWorld.state.season == 'summer' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_2"
        elseif TheWorld.state.season == 'winter' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_4"
        elseif TheWorld.state.season =='autumn' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_3"
        elseif TheWorld.state.season =='spring' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_1"
        end
    end
end

local function gainhealth(inst)
    inst.components.health:DoDelta(0.1)
    if inst.components.xxx3_skill.enabled == true then
       inst:DoTaskInTime(1, gainhealth)
    end
end

local function useskill(inst)
    inst._cdtask = inst:DoTaskInTime(1, OnCooldown) 
    if inst.components.xxx3_skill.enabled == false  then
        inst.components.xxx3_skill:SetEnabled(true)

        inst.sg:GoToState("xxx3_turnintobulb")
        inst.bulbfx = SpawnPrefab("xxx3_bulbfx")
        inst.bulbfx.Transform:SetScale(2, 2, 2)
        inst.bulbfx:DoTaskInTime(0.5, function()
            inst.bulbfx.Transform:SetPosition(Vector3(inst.Transform:GetWorldPosition()):Get())
        end)
        inst:DoTaskInTime(1, gainhealth)

        if inst.components.freezable then
            inst.components.freezable:SetResistance(300)
        end

        inst:AddComponent("xxx3_minionspawner")
        chooseeyeplant(inst);
        inst.components.xxx3_minionspawner.validtiletypes = VALID_TILE_TYPES
	    inst.components.xxx3_minionspawner.minionspawntime = { min = 0.08, max = 0.12 }
	    inst.components.xxx3_minionspawner.maxminions = 100
        inst.components.xxx3_minionspawner.distancemodifier = 10
        inst.components.xxx3_minionspawner.shouldspawn = true
        inst.components.xxx3_minionspawner:StartNextSpawn()
        inst.collectmyitems=inst:DoPeriodicTask(2.0,CollectItems)
    else
        inst.sg:GoToState("idle")
    end
end

local function CheckSea(inst)
    local Pi = 3.14159265
    local num = 16
    local x,y,z = inst.Transform:GetWorldPosition()
    local r = 5
    for i=0,num-1,1 do
        local db = i *1.0
        local nx = math.cos( db /(num/2) * Pi) * r
        local nz = math.sin( db /(num/2) * Pi) * r
        if TheWorld.Map:IsVisualGroundAtPoint(x+nx,y,z+nz) == false then
            return false
        end
    end
    return true
end

local function GROW(inst)
    if  not inst:HasTag("playerghost") and not inst.replica.health:IsDead() and inst._cdtask == nil then
        if inst:HasTag("xxx3") then
            local x,y,z = inst.Transform:GetWorldPosition()
            local ents = TheSim:FindEntities(x,y,z,5)
            local num = 0
            local hat = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
            if hat and hat.prefab == "bushhat" then
                inst.components.talker:Say("我不应该戴着这个扎根!")
                return
            end
            if inst.components.xxx3_skill.enabled == false  then
                for k, v in pairs(ents) do
                    if (v.prefab == "xxx3" and v.components.xxx3_skill.enabled == true) or v.prefab=='lureplant' then
                        inst.components.talker:Say("这里养分太少了，我应该离远一点扎根!")
                        num = 1
                        break
                    end
                end
            end
            if num == 0 then
                if not CheckSea(inst) then
                    inst.components.talker:Say("我不应该在悬崖边扎根！")
                else useskill(inst)
                end
            end

	    end
    end
end

AddModRPCHandler(modname, "GROW", GROW)  --添加对应rpc以及对应的funcion

TheInput:AddKeyDownHandler(GLOBAL.KEY_Z, function()
    local IsHUDscreen = GLOBAL.TheFrontEnd:GetActiveScreen() and GLOBAL.TheFrontEnd:GetActiveScreen().name == "HUD"
    if IsHUDscreen then
        SendModRPCToServer(MOD_RPC[modname]["GROW"])
    end
end)

-- 收获食人花
local function collectitems(lureplant, inst)
    if lureplant==nil or lureplant.components.inventory==nil then
        return
    end

	local items=lureplant.components.inventory:FindItems(function(item)
        return not item:HasTag("nosteal") and (lureplant.components.shelf==nil or item~=lureplant.components.shelf.itemonshelf)
    end)

    local judge = false
    for i,item in ipairs(items) do
	    if not inst.components.inventory:IsFull() then
            lureplant.components.inventory:RemoveItem(item,true)
            inst.components.inventory:GiveItem(item)
            judge = true
        else
            inst.components.talker:Say("不行了...")
            return true
        end
    end
    return judge
end
AddPrefabPostInit(
    'lureplant',
    function(inst)
        if not inst.SoundEmitter then
            inst.entity:AddSoundEmitter()
        end
        if TheWorld.ismastersim then
            inst:AddComponent('lureplant_pick')
        end
    end
)
local lureplant_pick = Action({priority = 1, mount_valid = true})
lureplant_pick.id = 'LUREPLANT_PICK'
lureplant_pick.str = '收集'
lureplant_pick.fn = function(action)
    if action.doer and action.doer.prefab == 'xxx3' then
        if not collectitems(action.target,action.doer) then
            action.doer.components.talker:Say("空的!")
        end
        return true
    else
        return false
    end
end
AddAction(lureplant_pick)
AddStategraphActionHandler('wilson', ActionHandler(lureplant_pick, 'dolongaction'))
AddStategraphActionHandler('wilson_client', ActionHandler(lureplant_pick, 'dolongaction'))
AddComponentAction(
    'SCENE',
    'lureplant_pick',
    function(inst, doer, actions, right)
        if doer:HasTag('xxx3') then
            table.insert(actions, lureplant_pick)
        end
    end
)