local MakePlayerCharacter = require "prefabs/player_common"
local brain = require "brains/xxx3brain"

local assets = {
    Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
}

-- Your character's stats
TUNING.XXX3_HEALTH = 90
TUNING.XXX3_HUNGER = 100
TUNING.XXX3_SANITY = 200

-- Custom starting inventory
TUNING.GAMEMODE_STARTING_ITEMS.DEFAULT.XXX3 = {
	"LUREPLANTBULB",
	"LUREPLANTBULB",
	"LUREPLANTBULB",
	"LUREPLANTBULB",
}


--摘花掉san
local function onpick(inst, data)
    if data.object.prefab == "flower" then
	    inst.components.sanity:DoDelta(-20)
	end
end

--在花边上回san
local function getsanfromflowers(inst)  
    local n = 0
	local x, y, z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, y, z, 5)
    for k,v in pairs(ents) do
		if v:HasTag("flower") then
			n = n+1
		end
	end
	inst.components.sanity.dapperness= 0.05 * n
end

local start_inv = {}
for k, v in pairs(TUNING.GAMEMODE_STARTING_ITEMS) do
    start_inv[string.lower(k)] = v.XXX3
end
local prefabs = FlattenTree(start_inv, true)

-- When the character is revived from human
local function onbecamehuman(inst)
	-- Set speed when not a ghost (optional)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "xxx3_speed_mod", 1)
	local x,y,z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x,y,z,4)
    for k, v in pairs(ents) do
        if v.prefab == "xxx3_bulbfx" then
      		v:Remove()
        end
    end 
end

local function onbecameghost(inst)
	-- Remove speed modifier when becoming a ghost
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "xxx3_speed_mod")
   if inst.components.minionspawner then
        inst.components.xxx3_skill:SetEnabled(false)
        inst.components.minionspawner.shouldspawn = false
        inst.components.minionspawner:KillAllMinions()
        inst:RemoveComponent("minionspawner")

		local x,y,z = inst.Transform:GetWorldPosition()
        local ents = TheSim:FindEntities(x,y,z,4)
        for k, v in pairs(ents) do
            if v.prefab == "xxx3_bulbfx" then
          		v:Remove()
            end
        end 
   end
end

-- When loading or spawning the character
local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end

-- This initializes for both the server and client. Tags can be added here.
local common_postinit = function(inst) 
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "xxx3.tex" )
	inst:AddTag("xxx3")
	inst:AddTag("eyeplant_friend")

end

local function seasonchange(inst,season)
    if inst.components.xxx3_minionspawner then
        inst.components.xxx3_minionspawner.shouldspawn = false
        inst.components.xxx3_minionspawner:KillAllMinions()
        if(season=='summer')then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_2"
        elseif season=='winter' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_4"
        elseif season=='autumn' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_3"
        elseif season=='spring' then
            inst.components.xxx3_minionspawner.miniontype="xxx3_eyeplant_1"
        end
        inst.components.xxx3_minionspawner.shouldspawn = true
    end
	if season ~= 'summer' then
		inst.components.health.fire_damage_scale = 1
	end
end

local function onattack(inst, tar)
    local target = tar.target
	if target.prefab == 'lureplant' and target.components.health and not target.components.health:IsDead() then
		target.components.health:DoDelta(-60)
	end
end
-- This initializes for the server only. Components are added here.
local master_postinit = function(inst)
	
	-- 选择这个角色将播放的声音
	inst.soundsname = "wendy"----在下面注释中选择（改了之后上面：Asset( "SOUND", "sound/wilson.fsb" )也要跟着改）
	--[[
wilson	（威尔逊）
waxwell	（麦斯威尔）
wendy	（温蒂）
woodie	（伍迪）
wes	（韦斯）
wickerbottom	（图书管理员）
willow	（薇洛）
wolfgang	（沃尔夫冈）
wx78	（机器人）
wathgrithr	（瓦丝格雷斯）
webber	（韦伯）
]]

	--自带一本/二本/三本科技（）：
	--inst.components.builder.bonus_tech_level = 【数字1或2或3】--这个好像不能用了
	--inst.components.builder.science_bonus = 2  --这句是老奶奶的

	-- 属性	
    inst.Transform:SetScale(1.0, 1.0, 1.0)
	--最大生命值
	inst.components.health:SetMaxHealth(90)
	--最大饥饿值
	inst.components.hunger:SetMax(100)
	--最大精神值
	inst.components.sanity:SetMax(200)
	inst.components.health.absorb = 0
	-- 损坏乘数 (可选)
    inst.components.combat.damagemultiplier = 1

	inst.components.combat:SetAttackPeriod(TUNING.WILSON_ATTACK_PERIOD*1)
	-- 饥饿率(可选)
	inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE	--0.15625
	-- 移动速度 (可选)
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1)
	--跑步速度
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1)
	inst.components.health:StartRegen(0,0)

	inst.components.sanity.no_moisture_penalty = true

	inst.attackSpeed=0
	inst.hasAttack=0
	inst.hasAttackDispear=0
	inst.OnLoad = onload
    inst.OnNewSpawn = onload

    inst:AddComponent("xxx3_skill")
	inst:WatchWorldState("season",seasonchange)

	inst:SetBrain(brain)

	inst:ListenForEvent("picksomething", onpick)
	inst:ListenForEvent("onattackother", onattack)
	inst:DoPeriodicTask(1, getsanfromflowers)
	-- inst:DoPeriodicTask(4, getposition)

end

return MakePlayerCharacter("xxx3", prefabs, assets, common_postinit, master_postinit, prefabs)


