local assets =
{
    Asset("ANIM", "anim/xxx3_bouquet.zip"),  --地上的动画
    Asset("ANIM", "anim/swap_xxx3_bouquet.zip"), --手里的动画
	Asset("ATLAS", "images/xxx3_bouquet.xml"), --加载物品栏贴图
    Asset("IMAGE", "images/xxx3_bouquet.tex"),
}
local function summon(inst)
    local x,y,z = inst.Transform:GetWorldPosition()
    if inst.killerbutterfly == nil then
        inst.killerbutterfly = {}
        for i=1,5,1 do
            table.insert(inst.killerbutterfly, nil)
        end
    end
    for i=1,5,1 do
        if inst.killerbutterfly[i] == nil or (inst.killerbutterfly[i] and not inst.killerbutterfly[i]:IsValid())then
            inst.killerbutterfly[i] = SpawnPrefab("xxx3_killerbutterfly")
            local radius = inst:GetPhysicsRadius(0) + .7 + math.random() * .5
            local angle = math.random() * 2 * PI
            local nx = x + radius * math.cos(angle)
            local nz = z - radius * math.sin(angle)
            inst.killerbutterfly[i].Transform:SetPosition(nx,0,nz)
            inst.killerbutterfly[i].components.follower:SetLeader(inst)
            inst.killerbutterfly[i].master = inst
            SpawnPrefab("sanity_lower").Transform:SetPosition(nx,0,nz)
        end
    end
end

local function remove(inst)
    for i=1,5,1 do
        if inst.killerbutterfly[i]~=nil and inst.killerbutterfly[i]:IsValid() then
            SpawnPrefab("sanity_raise").Transform:SetPosition(inst.killerbutterfly[i].Transform:GetWorldPosition())
            inst.killerbutterfly[i]:Remove()
            inst.killerbutterfly[i] = nil
        end
    end
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_xxx3_bouquet", "swap_xxx3_bouquet")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    summon(owner)
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
    remove(owner)
end

local function fn()
    local inst = CreateEntity()
    inst.entity:AddSoundEmitter()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("xxx3_bouquet") 
    inst.AnimState:SetBuild("xxx3_bouquet")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp") 
    inst:AddTag("pointy")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(1)

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/xxx3_bouquet.xml" 

    inst:AddComponent("equippable") 
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    MakeHauntableLaunch(inst)

    return inst
end

return Prefab("xxx3_bouquet", fn, assets)