local prefabs =
{
    "xxx3_healthregenbuff",
	"xxx3_butterflybuff",
}

local function oneaten_nmtd(inst, eater)
    if eater.components.debuffable ~= nil and eater.components.debuffable:IsEnabled() and
    not (eater.components.health ~= nil and eater.components.health:IsDead()) and not eater:HasTag("playerghost") then
        eater.components.debuffable:AddDebuff("xxx3_healthregenbuff", "xxx3_healthregenbuff")
    end
end

local function oneaten_hbsl(inst, eater)
    if eater.components.debuffable ~= nil and eater.components.debuffable:IsEnabled() and
    not (eater.components.health ~= nil and eater.components.health:IsDead()) and not eater:HasTag("playerghost") then
        eater.components.debuffable:AddDebuff("xxx3_butterflybuff", "xxx3_butterflybuff")
    end
end

local function foodfn(mc, nc, ms, hs)
    STRINGS.NAMES[string.upper(mc)] = nc
	STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(mc)] = ms
	return Prefab(mc, function()
		local inst = CreateEntity()
		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddNetwork()
		
		if not TheWorld.ismastersim then
			return inst
		end

		MakeInventoryPhysics(inst)
		
		inst.AnimState:SetBank(mc)
		inst.AnimState:SetBuild(mc)
		inst.AnimState:PlayAnimation("idle")
		
		if hs then
			hs(inst)
		end
		
		inst:AddComponent("stackable")--可堆叠组件
		inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM--堆叠上限40
		
		inst:AddComponent("inspectable")--可检查组件

		inst:AddComponent("inventoryitem")--物品组件
		inst.components.inventoryitem.atlasname = "images/" .. mc .. ".xml"--物品贴图
		return inst
	end,
	{
		Asset("ANIM", "anim/" .. mc .. ".zip"),
		Asset("ATLAS", "images/" .. mc .. ".xml"),
	})
end

return

foodfn("xxx3_hbsl", "花瓣沙拉", "花朵可是很美味的，不尝一下吗？", function(inst)
	inst:AddTag("preparedfood")
	
	inst:AddComponent("edible")--可食用的组件
	inst.components.edible.healthvalue = 50
	inst.components.edible.hungervalue = 25
	inst.components.edible.sanityvalue = 0
	inst.components.edible.foodtype = FOODTYPE.VEGGIE
	inst.components.edible:SetOnEatenFn(oneaten_hbsl)
	
	inst:AddComponent("perishable")--易腐烂的组件
	inst.components.perishable:SetPerishTime(TUNING.PERISH_FAST)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
end),

foodfn("xxx3_hjmdj", "黄金蜜蝶卷", "看上去就很甜", function(inst)
	inst:AddTag("preparedfood")
	
	inst:AddComponent("edible")--可食用的组件
	inst.components.edible.healthvalue = 35
	inst.components.edible.hungervalue = 50
	inst.components.edible.sanityvalue = 20
	inst.components.edible.foodtype = FOODTYPE.VEGGIE
	
	inst:AddComponent("perishable")--易腐烂的组件
	inst.components.perishable:SetPerishTime(TUNING.PERISH_MED)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
end),

foodfn("xxx3_hmhb", "花蜜汉堡", "应该能吃的饱饱的", function(inst)
	inst:AddTag("preparedfood")
	
	inst:AddComponent("edible")--可食用的组件
	inst.components.edible.healthvalue = 15
	inst.components.edible.hungervalue = 112.5
	inst.components.edible.sanityvalue = 5
	inst.components.edible.foodtype = FOODTYPE.MEAT 
	
	inst:AddComponent("perishable")--易腐烂的组件
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SLOW)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
end),

foodfn("xxx3_hjdg", "黄金蛋糕", "烘焙的美味", function(inst)
	inst:AddTag("preparedfood")
	
	inst:AddComponent("edible")--可食用的组件
	inst.components.edible.healthvalue = 40
	inst.components.edible.hungervalue = 85
	inst.components.edible.sanityvalue = 5
	inst.components.edible.foodtype = FOODTYPE.VEGGIE
	
	inst:AddComponent("perishable")--易腐烂的组件
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SLOW)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
end),

foodfn("xxx3_nmtd", "纳米糖豆", "某种神秘科技的产物", function(inst)
	inst:AddTag("preparedfood")
	
	inst:AddComponent("edible")--可食用的组件
	inst.components.edible.healthvalue = 0
	inst.components.edible.hungervalue = 2
	inst.components.edible.sanityvalue = 0
	inst.components.edible.foodtype = FOODTYPE.GOODIES
	inst.components.edible:SetOnEatenFn(oneaten_nmtd)
end)