local assets=
{
	Asset("ANIM", "anim/xxx3_hat.zip"),
	Asset("ATLAS", "images/xxx3_hat.xml")
}

local function onequip(inst, owner) 
        owner.AnimState:OverrideSymbol("swap_hat", "xxx3_hat", "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Show("HAT_HAIR")
        owner:AddTag("eyeplant_friend")
end

local function onunequip(inst, owner) 
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAT_HAIR")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")
        if owner.prefab ~= "xxx3" then
            owner:RemoveTag("eyeplant_friend")
        end
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	inst.entity:AddNetwork()
    
    inst:AddTag("hat")
	
    anim:SetBank("xxx3_hat")
    anim:SetBuild("xxx3_hat")
    anim:PlayAnimation("anim")    
        
    
    
	if not TheWorld.ismastersim then
        return inst
    end
    inst:AddComponent("tradable")
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/xxx3_hat.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable.dapperness = 0.1
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
    return inst
end

return Prefab( "common/inventory/xxx3_hat", fn, assets) 
