local assets =
{
    Asset("ANIM", "anim/xxx3_ydg.zip"),
	Asset("ATLAS", "images/xxx3_ydg.xml"),
	Asset("IMAGE", "images/xxx3_ydg.tex"),
}

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()
	inst.entity:AddLight()
	
	inst.AnimState:SetBank("xxx3_ydg")
	inst.AnimState:SetBuild("xxx3_ydg")
	inst.AnimState:PlayAnimation("idle")

	MakeInventoryPhysics(inst)

    MakeInventoryFloatable(inst)

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end

	inst.Light:Enable(true)
	inst.Light:SetRadius(.5)
    inst.Light:SetFalloff(.7)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(255/255, 255/255, 0/255)

	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")

	inst:AddComponent("edible")
	inst.components.edible.sanityvalue = 100

	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

	inst.components.inventoryitem.atlasname = "images/xxx3_ydg.xml"

	return inst
end

return Prefab("common/inventory/xxx3_ydg", fn, assets, prefabs)